<template>
  <div class="checkbox" :class="componentClasses">
    <input
      :id="uniqueId"
      ref="checkbox"
      :checked="checked"
      type="checkbox"
      :disabled="disabled"
      @input="toggleChecked"
    />
    <label :for="uniqueId" class="text">
      <sa-icon icon="check" aria-hidden="true" />
      {{ text }}
    </label>
  </div>
</template>

<script>
export default {
  name: 'SaInputCheckbox',
  props: {
    initiallyChecked: {
      type: Boolean,
      default: false
    },
    text: {
      type: String,
      required: true
    },
    size: {
      type: String,
      default: 'regular'
    },
    disabled: {
      type: Boolean,
      default: false
    },
    inError: {
      type: Boolean,
      default: false
    }
  },
  data(props) {
    return {
      checked: props.initiallyChecked,
      uniqueId: this.makeUniqueId()
    }
  },
  computed: {
    componentClasses() {
      const classes = [this.size]
      if (this.checked) {
        classes.push('checked')
      }
      if (this.inError) {
        classes.push('error')
      }
      if (this.disabled) {
        classes.push('disabled')
      }
      return classes
    }
  },
  methods: {
    toggleChecked() {
      this.checked = !this.checked
      this.$emit('change', this.checked)
    }
  }
}
</script>

<style lang="scss" scoped></style>
